require("utils")
require("config")

data:extend(
	{
		--------------------------------------------------------------------------------------
		{
			type = "item",
			name = "ucoin",
			icon = "__BlackMarket__/graphics/ucoin.png",
			flags = {"goes-to-quickbar"},
			subgroup = "science-pack",
			order = "y",
			stack_size = 1000000
		},
		--------------------------------------------------------------------------------------
		{
			type = "technology",
			name = "black-market-item",
			icon = "__BlackMarket__/graphics/black-market-item.png",
			icon_size = 128,
			enabled = true,
			prerequisites = { "steel-processing" },
			unit = {
				count = 75,
				ingredients = {
					{"science-pack-1", 1},
				},
				time = 15
			},
			effects =
			{
				{
					type = "unlock-recipe",
					recipe = "trading-chest-sell",
				},
				{
					type = "unlock-recipe",
					recipe = "trading-chest-buy",
				},
			},
			order = "k-z-a",
		},
		--------------------------------------------------------------------------------------
		{
			type = "technology",
			name = "black-market-fluid",
			icon = "__BlackMarket__/graphics/black-market-fluid.png",
			icon_size = 128,
			-- enabled = false,
			enabled = true,
			prerequisites = { "black-market-item", "fluid-handling" },
			unit = {
				count = 75,
				ingredients = {
					{"science-pack-1", 1},
					{"science-pack-2", 1},
				},
				time = 20
			},
			effects =
			{
				{
					type = "unlock-recipe",
					recipe = "trading-tank-sell",
				},
				{
					type = "unlock-recipe",
					recipe = "trading-tank-buy",
				},
			},
			order = "k-z-b",
		},
		--------------------------------------------------------------------------------------
		{
			type = "technology",
			name = "black-market-energy",
			icon = "__BlackMarket__/graphics/black-market-energy.png",
			icon_size = 128,
			-- enabled = false,
			enabled = true,
			prerequisites = { "black-market-item", "electric-energy-accumulators-1" },
			unit = {
				count = 150,
				ingredients = {
					{"science-pack-1", 1},
					{"science-pack-2", 1},
				},
				time = 25
			},
			effects =
			{
				{
					type = "unlock-recipe",
					recipe = "trading-accumulator-sell",
				},
				{
					type = "unlock-recipe",
					recipe = "trading-accumulator-buy",
				},
			},
			order = "k-z-c",
		},
	}
)


--------------------------------------------------------------------------------------
local chest_sell = dupli_proto( "container", "steel-chest", "trading-chest-sell", true )
chest_sell.inventory_size = 50
chest_sell.picture = 
    {
		filename = "__BlackMarket__/graphics/trading-chest-sell.png",
		priority = "extra-high",
		width = 48,
		height = 34,
		shift = {0.1875, 0}
    }

data:extend(
	{
		chest_sell,

		{
			type = "item",
			name = "trading-chest-sell",
			icon = "__BlackMarket__/graphics/trading-chest-sell-icon.png",
			flags = {"goes-to-quickbar"},
			subgroup = "storage",
			order = "a[items]-za",
			place_result = "trading-chest-sell",
			stack_size = 50,
		},
		
		{
			type = "recipe",
			name = "trading-chest-sell",
			enabled = false,
			energy_required = 1,
			ingredients = {
				{"steel-chest", 1},
				{"electronic-circuit", 2},
			},
			result = "trading-chest-sell",
		},
	}
)

--------------------------------------------------------------------------------------
local chest_buy = dupli_proto( "container", "steel-chest", "trading-chest-buy", true )
chest_buy.inventory_size = 50
chest_buy.picture = 
    {
		filename = "__BlackMarket__/graphics/trading-chest-buy.png",
		priority = "extra-high",
		width = 48,
		height = 34,
		shift = {0.1875, 0}
    }

data:extend(
	{
		chest_buy,

		{
			type = "item",
			name = "trading-chest-buy",
			icon = "__BlackMarket__/graphics/trading-chest-buy-icon.png",
			flags = {"goes-to-quickbar"},
			subgroup = "storage",
			order = "a[items]-zb",
			place_result = "trading-chest-buy",
			stack_size = 50,
		},
		
		{
			type = "recipe",
			name = "trading-chest-buy",
			enabled = false,
			energy_required = 1,
			ingredients = {
				{"steel-chest", 1},
				{"electronic-circuit", 2},
			},
			result = "trading-chest-buy",
		},
	}
)

--------------------------------------------------------------------------------------
local tank_sell = dupli_proto( "storage-tank", "storage-tank", "trading-tank-sell", true )
tank_sell.pictures.picture.sheet.filename = "__BlackMarket__/graphics/trading-tank-sell.png"
tank_sell.fluid_box.base_area = tank_max/10

data:extend(
	{
		tank_sell,

		{
			type = "item",
			name = "trading-tank-sell",
			icon = "__BlackMarket__/graphics/trading-tank-sell-icon.png",
			flags = {"goes-to-quickbar"},
			subgroup = "storage",
			order = "b[fluid]-za",
			place_result = "trading-tank-sell",
			stack_size = 50,
		},
		
		{
			type = "recipe",
			name = "trading-tank-sell",
			enabled = false,
			energy_required = 4,
			ingredients = {
				{"storage-tank", 1},
				{"electronic-circuit", 2},
			},
			result = "trading-tank-sell",
		},
	}
)

--------------------------------------------------------------------------------------
local tank_buy = dupli_proto( "storage-tank", "storage-tank", "trading-tank-buy", true )
tank_buy.pictures.picture.sheet.filename = "__BlackMarket__/graphics/trading-tank-buy.png"
tank_buy.fluid_box.base_area = tank_max/10

data:extend(
	{
		tank_buy,

		{
			type = "item",
			name = "trading-tank-buy",
			icon = "__BlackMarket__/graphics/trading-tank-buy-icon.png",
			flags = {"goes-to-quickbar"},
			subgroup = "storage",
			order = "b[fluid]-zb",
			place_result = "trading-tank-buy",
			stack_size = 50,
		},
		
		{
			type = "recipe",
			name = "trading-tank-buy",
			enabled = false,
			energy_required = 4,
			ingredients = {
				{"storage-tank", 1},
				{"electronic-circuit", 2},
			},
			result = "trading-tank-buy",
		},
	}
)

--------------------------------------------------------------------------------------
local accu_sell = dupli_proto( "accumulator", "accumulator", "trading-accumulator-sell", true )
accu_sell.energy_source =
    {
		type = "electric",
		-- buffer_capacity = "50MJ",
		buffer_capacity = accu_max .. "J",
		usage_priority = "terciary",
		input_flow_limit = "1MW",
		output_flow_limit = "0kW"
    }
accu_sell.picture.filename = "__BlackMarket__/graphics/trading-accumulator-sell.png"
accu_sell.charge_animation.filename = "__BlackMarket__/graphics/trading-accumulator-sell-charge.png"
accu_sell.discharge_animation.filename = "__BlackMarket__/graphics/trading-accumulator-sell-discharge.png"

data:extend(
	{
		accu_sell,

		{
			type = "item",
			name = "trading-accumulator-sell",
			icon = "__BlackMarket__/graphics/trading-accumulator-sell-icon.png",
			flags = {"goes-to-quickbar"},
			subgroup = "energy",
			order = "e[accumulator]-za",
			place_result = "trading-accumulator-sell",
			stack_size = 50,
		},
		
		{
			type = "recipe",
			name = "trading-accumulator-sell",
			enabled = false,
			energy_required = 20,
			ingredients = {
				{"accumulator", 2},
				{"electronic-circuit", 2},
			},
			result = "trading-accumulator-sell",
		},
	}
)

--------------------------------------------------------------------------------------
local accu_buy = dupli_proto( "accumulator", "accumulator", "trading-accumulator-buy", true )
accu_buy.energy_source =
    {
		type = "electric",
		-- buffer_capacity = "50MJ",
		buffer_capacity = accu_max .. "J",
		usage_priority = "terciary",
		input_flow_limit = "0kW",
		output_flow_limit = "1000kW"
    }
accu_buy.picture.filename = "__BlackMarket__/graphics/trading-accumulator-buy.png"
accu_buy.charge_animation.filename = "__BlackMarket__/graphics/trading-accumulator-buy-charge.png"
accu_buy.discharge_animation.filename = "__BlackMarket__/graphics/trading-accumulator-buy-discharge.png"

data:extend(
	{
		accu_buy,

		{
			type = "item",
			name = "trading-accumulator-buy",
			icon = "__BlackMarket__/graphics/trading-accumulator-buy-icon.png",
			flags = {"goes-to-quickbar"},
			subgroup = "energy",
			order = "e[accumulator]-zb",
			place_result = "trading-accumulator-buy",
			stack_size = 50,
		},
		
		{
			type = "recipe",
			name = "trading-accumulator-buy",
			enabled = false,
			energy_required = 20,
			ingredients = {
				{"accumulator", 2},
				{"electronic-circuit", 2},
			},
			result = "trading-accumulator-buy",
		},
	}
)

